//+------------------------------------------------------------------+
//|                                                 SSA of price.mq4 |
//|                                                           mladen |
//| forex-tsd elite section only                                     |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//    max arraySize - 5000
//    max lag - 200 (but will be slow for big lags)
//    max numberOfComputations - 20 (it just makes it "fit" more precise to source array)
//
//

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern string TimeFrame            = "Current time frame";
extern int    Lag                  =   25;
extern int    NumberOfComputations =    2;
extern int    NumberOfBars         = 2000;
extern int    Price                = PRICE_CLOSE;
extern bool   alertsOn             = false;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
//
//
//

double SSA[];
double SSAUp[];
double SSADn[];
double trend[];
double sourceValues[];
double calcValues[];


//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,SSAUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,SSADn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,SSA);
   SetIndexBuffer(3,trend);
   
         //
         //
         //
         //
         //
         
         NumberOfBars      = MathMin(NumberOfBars,5000);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
   IndicatorShortName(timeFrameToString(timeFrame)+" SSA of price hist ("+Lag+")");         
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit;

      if (NumberOfBars>0)
            limit = (Bars-1);
      else  limit = MathMin(Bars-1,NumberOfBars);
      if (returnBars) { SSAUp[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {      
         if (ArraySize(sourceValues) != limit) { ArrayResize(sourceValues,limit); ArrayResize(calcValues,limit); }
         
         //
         //
         //
         //
         //
         
         for(i=limit; i>=0; i--)  sourceValues[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
                                  fastSingular(sourceValues,limit,Lag,NumberOfComputations,calcValues); ArrayCopy(SSA,calcValues);
         for(i=limit; i>=0; i--)  
         {
            SSAUp[i] = EMPTY_VALUE;
            SSADn[i] = EMPTY_VALUE;
            trend[i] = trend[i+1];
               if (SSA[i]>SSA[i+1]) trend[i] =  1;
               if (SSA[i]<SSA[i+1]) trend[i] = -1;
               if (trend[i]== 1) SSAUp[i] = 1;
               if (trend[i]==-1) SSADn[i] = 1;
         }
         manageAlerts();
         return(0);
   }
            
   //
   //
   //
   //
   //
 
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         SSAUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lag,NumberOfComputations,NumberOfBars,Price,0,y);
         SSADn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lag,NumberOfComputations,NumberOfBars,Price,1,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lag,NumberOfComputations,NumberOfBars,Price,3,y);
   }
   manageAlerts();   
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;  whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      int lastBar = Lag; if (Period()<timeFrame) lastBar = Lag*timeFrame/Period();
      
      for (;whichBar<lastBar; whichBar++)
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] ==  1) doAlert(whichBar,"up");
            if (trend[whichBar] == -1) doAlert(whichBar,"down");
            break;
         }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SSA at bar ",TimeToStr(previousTime,TIME_DATE|TIME_SECONDS)," changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SSA of price"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}